// mainfrm.cpp : implementation of the CMainFrame class
//
//
// Copyright (c) 1995 by R. E. Frazier - all rights reserved
//
// This program and source provided for example purposes.  You may
// redistribute it so long as no modifications are made to any of
// the source files, and the above copyright notice has been 
// included.  You may also use portions of the sample code in your
// own programs, as desired.

#include "stdafx.h"
#include "sortdemo.h"
#include "mainview.h"
#include "sortproc.h"

#include "mainfrm.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// CMainFrame

//IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(IDM_SORT_EXIT, OnSortExit)
	ON_COMMAND(IDM_SORT_HEAP, OnSortHeap)
	ON_COMMAND(IDM_SORT_INSERTION, OnSortInsertion)
	ON_COMMAND(IDM_SORT_QUICK, OnSortQuick)
	ON_COMMAND(IDM_SORT_THREAD_QUICK, OnSortThreadQuick)
	ON_COMMAND(IDM_SORT_SHELL, OnSortShell)
	ON_COMMAND(IDM_SORT_EXCHANGE, OnSortExchange)
	ON_COMMAND(IDM_SORT_BUBBLE, OnSortBubble)
	ON_COMMAND(IDM_SORT_KILL, OnSortKill)
	ON_UPDATE_COMMAND_UI(IDM_SORT_BUBBLE, OnUpdateSortBubble)
	ON_UPDATE_COMMAND_UI(IDM_SORT_EXCHANGE, OnUpdateSortExchange)
	ON_UPDATE_COMMAND_UI(IDM_SORT_HEAP, OnUpdateSortHeap)
	ON_UPDATE_COMMAND_UI(IDM_SORT_INSERTION, OnUpdateSortInsertion)
	ON_UPDATE_COMMAND_UI(IDM_SORT_KILL, OnUpdateSortKill)
	ON_UPDATE_COMMAND_UI(IDM_SORT_NEWDATA, OnUpdateSortNewdata)
	ON_UPDATE_COMMAND_UI(IDM_SORT_QUICK, OnUpdateSortQuick)
	ON_UPDATE_COMMAND_UI(IDM_SORT_THREAD_QUICK, OnUpdateSortThreadQuick)
	ON_UPDATE_COMMAND_UI(IDM_SORT_RESTORE, OnUpdateSortRestore)
	ON_UPDATE_COMMAND_UI(IDM_SORT_SHELL, OnUpdateSortShell)
	ON_COMMAND(IDM_SORT_HEAP2, OnSortHeap2)
	ON_UPDATE_COMMAND_UI(IDM_SORT_HEAP2, OnUpdateSortHeap2)
	//}}AFX_MSG_MAP

   ON_COMMAND(IDM_SORT_COMPLETE, OnSortComplete)

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// arrays of IDs used to initialize control bars
	
// toolbar buttons - IDs are command buttons
static UINT BASED_CODE buttons[] =
{
	// same order as in the bitmap 'toolbar.bmp'
	IDM_SORT_NEWDATA,
  IDM_SORT_RESTORE,
		ID_SEPARATOR,
	IDM_SORT_INSERTION,
	IDM_SORT_BUBBLE,
	IDM_SORT_EXCHANGE,
	IDM_SORT_SHELL,
	IDM_SORT_HEAP,
  IDM_SORT_HEAP2,
  IDM_SORT_QUICK,
  IDM_SORT_THREAD_QUICK,
		ID_SEPARATOR,
  IDM_SORT_KILL,
    ID_SEPARATOR,
	ID_APP_ABOUT
};

static UINT BASED_CODE indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
   m_bEnable = TRUE;  // important - enables sort menu & button items
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadBitmap(IDR_MAINFRAME) ||
		!m_wndToolBar.SetButtons(buttons,
		  sizeof(buttons)/sizeof(UINT)))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

   if (!m_wndMainView.Create(NULL,NULL,AFX_WS_DEFAULT_VIEW,
                             CRect(0,0,0,0),this,AFX_IDW_PANE_FIRST))
   {
      TRACE0("Failed to create main view\n");
      return(-1);  // fail to create
   }
       

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	// TODO: Remove this if you don't want tool tips
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY);

	return 0;
}

//BOOL CMainFrame::OnCreateClient( LPCREATESTRUCT /*lpcs*/,
//	CCreateContext* pContext)
//{
//	return m_wndSplitter.Create( this,
//		2, 2,                 // TODO: adjust the number of rows, columns
//		CSize( 10, 10 ),      // TODO: adjust the minimum pane size
//		pContext );
//}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnSortExit() 
{
	PostQuitMessage(0);
}


DWORD dwStartTime;

void CMainFrame::SortInfo(LPCSTR szSortName)
{
char tbuf[256];

   wsprintf(tbuf, "Sort: %s  %d swaps, %d compares, %d milliseconds",
            szSortName, iSwaps, iCompares,
            (GetTickCount() - dwStartTime));

   MessageBox(tbuf, "* SORT RESULTS *", MB_ICONINFORMATION);  
}

void SortInfo(LPCSTR szSortName)
{
char tbuf[256];

   wsprintf(tbuf, "Sort: %s  %d swaps, %d compares, %d milliseconds",
            szSortName, iSwaps, iCompares,
            (GetTickCount() - dwStartTime));

   MessageBox(theApp.m_pMainWnd->m_hWnd, tbuf, 
              "* SORT RESULTS *", MB_ICONINFORMATION);
}

void CMainFrame::EnableSortMenuItems(BOOL bEnable)
{
   m_bEnable = bEnable;
}

DWORD CALLBACK SortThread(LPVOID lpvParms)
{
   dwStartTime = GetTickCount();

   switch((UINT)lpvParms)
   {
      case IDM_SORT_HEAP:
         HeapSort();
         SortInfo("Heap Sort (1)");
         break;
         
      case IDM_SORT_HEAP2:
         HeapSort2();
         SortInfo("Heap Sort (2)");
         break;
         
      case IDM_SORT_QUICK:
         QuickSort();
         SortInfo("Quick Sort");
         break;

      case IDM_SORT_THREAD_QUICK:
         ThreadQuickSort();
         SortInfo("Threaded Quick Sort");
         break;

      case IDM_SORT_BUBBLE:
         BubbleSort();
         SortInfo("Bubble Sort");
         break;

      case IDM_SORT_SHELL:
         ShellSort();
         SortInfo("Shell Sort");
         break;

      case IDM_SORT_INSERTION:
         InsertionSort();
         SortInfo("Insertion Sort");
         break;

      case IDM_SORT_EXCHANGE:
         ExchangeSort();
         SortInfo("Exchange Sort");
         break;
   }

   theApp.m_hSortThread = INVALID_HANDLE_VALUE;

   SendMessage(((CMainFrame *)theApp.m_pMainWnd)->m_hWnd, WM_COMMAND,
               (WPARAM)IDM_SORT_COMPLETE, NULL);
   return(0);
}

void CMainFrame::CreateSortThread(UINT uiParms)
{
DWORD dwRval;  

   // temporarily disable menu (and buttons)
   EnableSortMenuItems(0);

   theApp.m_hSortThread = CreateThread(NULL, 0, SortThread, 
                                       (LPVOID)uiParms,
                                       0, &dwRval);

   if(theApp.m_hSortThread == INVALID_HANDLE_VALUE)
   {
      MessageBox("?Unable to spawn thread for sort");
      EnableSortMenuItems(1);
   }            
}

afx_msg void CMainFrame::OnSortComplete()
{
   EnableSortMenuItems(1);
}

void CMainFrame::OnSortKill() 
{
   WaitForSingleObject(theApp.m_hSortMutex, 5000);  // wait max 5 seconds

   if(SuspendThread(theApp.m_hSortThread) == 0xffffffff)
   {
      MessageBox("Unable to suspend thread prior to 'terminating' it!");
   }
   else if(!TerminateThread(theApp.m_hSortThread, 0))
   {
      MessageBox("Unable to terminate thread!!! Thread will resume.");
      ResumeThread(theApp.m_hSortThread);
   }
   else
   {
	   OnSortComplete();
   }

   ReleaseMutex(theApp.m_hSortMutex);
}


// SORT MENU FUNCTIONS

void CMainFrame::OnSortHeap() 
{
   CreateSortThread(IDM_SORT_HEAP);   
}

void CMainFrame::OnSortHeap2() 
{
   CreateSortThread(IDM_SORT_HEAP2);
}

void CMainFrame::OnSortInsertion() 
{
   CreateSortThread(IDM_SORT_INSERTION);
}

void CMainFrame::OnSortQuick() 
{
   CreateSortThread(IDM_SORT_QUICK);   
}

void CMainFrame::OnSortThreadQuick() 
{
   CreateSortThread(IDM_SORT_THREAD_QUICK);   
}

void CMainFrame::OnSortShell() 
{
   CreateSortThread(IDM_SORT_SHELL);   
}

void CMainFrame::OnSortExchange() 
{
   CreateSortThread(IDM_SORT_EXCHANGE);   
}

void CMainFrame::OnSortBubble() 
{
   CreateSortThread(IDM_SORT_BUBBLE);
}



void CMainFrame::OnUpdateSortBubble(CCmdUI* pCmdUI) 
{
   pCmdUI->Enable(m_bEnable);
}

void CMainFrame::OnUpdateSortExchange(CCmdUI* pCmdUI) 
{
   pCmdUI->Enable(m_bEnable);
}

void CMainFrame::OnUpdateSortHeap(CCmdUI* pCmdUI) 
{
   pCmdUI->Enable(m_bEnable);
}

void CMainFrame::OnUpdateSortHeap2(CCmdUI* pCmdUI) 
{
   pCmdUI->Enable(m_bEnable);
}

void CMainFrame::OnUpdateSortInsertion(CCmdUI* pCmdUI) 
{
   pCmdUI->Enable(m_bEnable);
}

void CMainFrame::OnUpdateSortQuick(CCmdUI* pCmdUI) 
{
   pCmdUI->Enable(m_bEnable);
}

void CMainFrame::OnUpdateSortThreadQuick(CCmdUI* pCmdUI) 
{
   pCmdUI->Enable(m_bEnable);
}

void CMainFrame::OnUpdateSortShell(CCmdUI* pCmdUI) 
{
   pCmdUI->Enable(m_bEnable);
}

void CMainFrame::OnUpdateSortNewdata(CCmdUI* pCmdUI) 
{
   pCmdUI->Enable(m_bEnable);
}

void CMainFrame::OnUpdateSortRestore(CCmdUI* pCmdUI) 
{
   pCmdUI->Enable(m_bEnable);
}

void CMainFrame::OnUpdateSortKill(CCmdUI* pCmdUI) 
{
   pCmdUI->Enable(!m_bEnable);  // this one is reverse of others...
}

